/*
 * 쐬: 2005/06/16
 * Member DAO NX
 */
package diaop.dao;

import java.util.List;

import org.springframework.orm.hibernate.HibernateTemplate;

import diaop.model.Member;

/**
 * MemberDao
 *
 * @author Hiroshi TAKEMOTO
 */
public class HibernateMemberDao extends MemoryMemberDao 
implements IMember {
	protected HibernateTemplate	template;

	public Member[] findAllMembers() {
		List list = template.loadAll(Member.class);
		return (list != null 
			? (Member[])list.toArray(new Member[list.size()])
			: null);
	}
	public void deleteMember(Member member) {
		template.delete(member);
	}
	public Member findMember(Integer id) {
		return ((Member)template.load(Member.class, id));
	}
	public void insertMember(Member member) {
		template.save(member);
	}
	public void setTemplate(HibernateTemplate template) {
		this.template = template;
	}
}
