package diaop.dao;

import java.util.Map;

import diaop.model.Member;

public class MemoryMemberDao implements IMember {
	private Map	members;
	public void insertMember(Member member) {
		members.put(member.getId().toString(), member);
	}
	public void deleteMember(Member member) {
		members.remove(member.getId().toString());
	}
	public Member findMember(Integer id) {
		return (Member)members.get(id.toString());
	}
	public Member[] findAllMembers() {
		return (Member[])members.values().toArray(new Member[members.size()]);
	}
	public String printMember(Member member) {
		if (member != null) {
			StringBuffer	buf = new StringBuffer("MEMBER:");
			if (member.getId() != null) 	buf.append(" ID=" + member.getId());
			if (member.getName() != null)	buf.append(" NAME=" + member.getName());
			if (member.getAddress() != null)	buf.append(" ADDRESS=" + member.getAddress());
			return (buf.toString());
		}
		else {
			return ("NULL");
		}
	}
	public void setMembers(Map members) {
		this.members = members;
	}
}
