/*
 * 쐬: 2005/06/04
 * RtBOt@Cbean`o͂
 */
package diaop.proxy;

import java.lang.reflect.*;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.BeanPostProcessor;

/**
 * BeanDefinitionCounter
 *
 * @author Hiroshi TAKEMOTO
 */
public class BeforeLogProxy 
implements BeanPostProcessor, InvocationHandler  {
	private Object	orgObj;
	private String	targetName;
	
	/* ( Javadoc)
	 * @see java.lang.reflect.InvocationHandler#invoke(java.lang.Object, java.lang.reflect.Method, java.lang.Object[])
	 */
	public Object invoke(Object proxy, Method method, Object[] args)
		throws Throwable {
		System.out.println("Enter: " + method.getName());
		return method.invoke(orgObj, args);
	}

	/* ( Javadoc)
	 * @see org.springframework.beans.factory.config.BeanPostProcessor#postProcessAfterInitialization(java.lang.Object, java.lang.String)
	 */
	public Object postProcessAfterInitialization(Object bean, String beanName)
		throws BeansException {
		if (beanName.equals(targetName)) {
			orgObj = bean;
			return Proxy.newProxyInstance(
				bean.getClass().getClassLoader(),
				bean.getClass().getInterfaces(),
				this);
		}
		else {
			return bean;
		}
	}

	/* ( Javadoc)
	 * @see org.springframework.beans.factory.config.BeanPostProcessor#postProcessBeforeInitialization(java.lang.Object, java.lang.String)
	 */
	public Object postProcessBeforeInitialization(Object bean, String beanName)
		throws BeansException {
		// Ȃ̂ŃIWiԂ
		return bean;
	}

	/**
	 * @param string
	 */
	public void setTargetName(String string) {
		targetName = string;
	}

}
