package diaop.util;

import java.beans.BeanInfo;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.sql.Date;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

/**
 * EDbHelper<br>
 * Spring Ł@DbUtilsgp邽߂̃f[^x[Xwp[łAIuWFNgɑΉ
 * e[u̍쐬AR[h̑}AXVA폜ɑΉSQL𐶐B
 *
 * @version 1.0	2005/06/10
 * @author Hiroshi TAKEMOTO
 */
public class DbHelper {
	private String 				clsName;	// NXpX
	private String					objLabel;	// NXpX̍Ō̖O
	private List					propList;

	/**
	 * RXgN^[
	 * @param obj	wp[𐶐NX
	 */
	public DbHelper(Class cls) {
		clsName = cls.getName();
		try {
			StringTokenizer	tk = new StringTokenizer(clsName, ".");
			while (tk.hasMoreTokens()) {
				objLabel = tk.nextToken();
			}
			BeanInfo 				info = Introspector.getBeanInfo(cls);
			PropertyDescriptor[]	objProps = info.getPropertyDescriptors();
			/**
			 * getter, setterĂ̂cao^pƂ
			 */
			propList = new ArrayList();
			for (int i = 0; i < objProps.length; i++) {
				Method	getMethod = objProps[i].getReadMethod();
				Method	setMethod = objProps[i].getWriteMethod();
				if (getMethod != null && setMethod != null) {
					propList.add(objProps[i]);
				}
			}
		}
		catch (Exception e) {
		}		
	}
	/**
	 * RXgN^[
	 * @param obj	wp[𐶐IuGWFNg
	 */
	public DbHelper(Object obj) {
		this(obj.getClass());	
	}
	
	/**
	 * EDbHelperɑΉIuWFNg𕶎ŕ\B<br>
	 * \`́ANXF@o[=l, ... ׂẴo[ɑ΂JԂB<br>
	 * P̃eXg̃IuGWFNƂ̔rɗpƕ֗łB
	 * @param obj	IuWFNg
	 * @return	\
	 */
	public String toString(Object obj) {
		if (!isInstanceOfMyClass(obj))
			return (null);
		StringBuffer buf = new StringBuffer();
		buf.append(objLabel.toUpperCase() + ":");
		for (int i = 0; i < propList.size(); i++) {
			PropertyDescriptor objProp = (PropertyDescriptor)propList.get(i);
			String	propName = objProp.getName().toUpperCase();
			Class	propType = objProp.getPropertyType();
			Method	getMethod = objProp.getReadMethod();
			if (propName.equals("CLASS"))	// IuWFNgg
				continue;	
			Object	propValue = null;
			try {
				propValue = getMethod.invoke(obj, null);
			}
			catch (Exception e) {
				propValue = null;
			}
			if (propValue != null) {
				if (Integer.class.equals(propType) ||
					Double.class.equals(propType) ||
					Boolean.class.equals(propType)) 
				{
					buf.append(" ");
					buf.append(propName);
					buf.append("=");
					buf.append(propValue.toString());
				}
				else if (Date.class.equals(propType)) {
					SimpleDateFormat fmt = new SimpleDateFormat("yyyy-MM-dd");
					buf.append(" ");
					buf.append(propName);
					buf.append("='");
					buf.append(fmt.format(propValue));
					buf.append("'");
				}
				else if (String.class.equals(propType) ||
						Timestamp.class.equals(propType)) 
				{			
					buf.append(" ");
					buf.append(propName);
					buf.append("='");
					buf.append(propValue.toString());
					buf.append("'");
				}
			}
		}
		return (buf.toString());
	}

	/**
	 * EDbHelperɑΉIuWFNgDbUnitXML`ŕ\B<br>
	 * @param obj	IuWFNg
	 * @return	DbUnitXML`
	 */
	public String toDbUnitFormat(Object obj) {
		if (!isInstanceOfMyClass(obj))
			return (null);
		StringBuffer buf = new StringBuffer();
		buf.append("\t<" + getTableName());
		for (int i = 0; i < propList.size(); i++) {
			PropertyDescriptor objProp = (PropertyDescriptor)propList.get(i);
			String	propName = objProp.getName();
			Class	propType = objProp.getPropertyType();
			Method	getMethod = objProp.getReadMethod();
			if (propName.equals("CLASS"))	// IuWFNgg
				continue;	
			Object	propValue = null;
			try {
				propValue = getMethod.invoke(obj, null);
			}
			catch (Exception e) {
				propValue = null;
			}
			if (propValue != null) {
				if (Integer.class.equals(propType) ||
					Double.class.equals(propType) ||
					Boolean.class.equals(propType) ||
					String.class.equals(propType) ||
					Date.class.equals(propType) ||
					Timestamp.class.equals(propType)) 
				{
					buf.append("\n\t\t");
					buf.append(propName);
					buf.append("='");
					buf.append(propValue.toString());
					buf.append("'");
				}
			}
		}
		buf.append("/>\n");
		return (buf.toString());
	}

	public String getTableName() {
		return ("T_" + objLabel.toUpperCase());	
	}
	
	/**
	 * IuWFNgCREATE TABLE𐶐B
	 * @return	CREATE TABLE
	 */
	public String getCreateTableStmt() {
		StringBuffer buf = new StringBuffer();
		buf.append("CREATE TABLE " + getTableName());
		buf.append(	"(ID INTEGER NOT NULL PRIMARY KEY");
		for (int i = 0; i < propList.size(); i++) {
			PropertyDescriptor objProp = (PropertyDescriptor)propList.get(i);
			String	propName = objProp.getName().toUpperCase();
			Class	propType = objProp.getPropertyType();
			Method	getMethod = objProp.getReadMethod();
			Method	setMethod = objProp.getWriteMethod();
			if (propName.equals("ID"))		// ID͌ŒƂ
				continue;
			if (propName.equals("CLASS"))	// IuWFNgg
				continue;	
			// getter, setterĂ̂gp
			if (setMethod == null || getMethod == null)
				continue;
			// volatile錾ꂽϐ͂caɂ́A܂߂Ȃ
			if (Modifier.isVolatile(propType.getModifiers()))
				continue;
			if (Integer.class.equals(propType)) {
				buf.append("," + propName + " INTEGER");
			}
			else if (Double.class.equals(propType)) {
				buf.append("," + propName + " DOUBLE");
			}
			else if (String.class.equals(propType)) {
				buf.append("," + propName + " VARCHAR");
			}
			else if (Boolean.class.equals(propType)) {
				buf.append("," + propName + " BIT");
			}			
			else if (Date.class.equals(propType)) {
				buf.append("," + propName + " DATE");
			}
			else if (Timestamp.class.equals(propType)) {
				buf.append("," + propName + " TIMESTAMP");
			}
		}
		buf.append(")");		
		return (buf.toString());
	}
	
	/**
	 * Hibernatephbm.Xml𐶐
	 * @param obj	IuWFNg
	 * @return	Hibernatephbm.Xml
	 */
	public String getHibernateXml() {		
		StringBuffer buf = new StringBuffer();
		buf.append("<?xml version=\"1.0\" encoding=\"Windows-31J\"?>\n");
		buf.append("<!DOCTYPE hibernate-mapping");
		buf.append("\tPUBLIC \"-//Hibernate/Hibernate Mapping DTD//EN\"\n");
		buf.append("\t\"http://hibernate.sourceforge.net/hibernate-mapping-2.0.dtd\">\n");
		buf.append("<hibernate-mapping>\n");
		buf.append("\t<class \n");
		buf.append("\t\tname=\"" + getClsName() + "\"\n");
		buf.append("\t\ttable=\"" + getTableName() + "\">\n");
		buf.append("\t\t<id name=\"id\">\n");
		buf.append("\t\t\t<generator class=\"increment\"/>\n");
		buf.append("\t\t</id>\n");
		
		// JZbg
		for (int i = 0; i < propList.size(); i++) {
			PropertyDescriptor objProp = (PropertyDescriptor)propList.get(i);
			String	propName = objProp.getName();
			Class	propType = objProp.getPropertyType();
			Method	getMethod = objProp.getReadMethod();
			Method	setMethod = objProp.getWriteMethod();
			if (propName.toUpperCase().equals("ID"))		// ID͌ŒƂ
				continue;
			if (propName.toUpperCase().equals("CLASS"))	// IuWFNgg
				continue;	
			// getter, setterĂ̂gp
			if (setMethod == null || getMethod == null)
				continue;
			// volatile錾ꂽϐ͂caɂ́A܂߂Ȃ
			if (Modifier.isVolatile(propType.getModifiers()))
				continue;

			if (Integer.class.equals(propType) ||
				Double.class.equals(propType) ||
				String.class.equals(propType) ||
				Boolean.class.equals(propType) ||
				Date.class.equals(propType) ||
				Timestamp.class.equals(propType)) {
				buf.append("\t\t<property name=\"" + propName + "\"/>\n");
			}				
		}
		buf.append("\t</class>\n");
		buf.append("</hibernate-mapping>\n");
		return (buf.toString());				
	}
	
	/**
	 * IuWFNgPropertyDescriptor̃XgԂ
	 * @return	IuWFNgPropertyDescriptor
	 */
	public List getPropList() {
		return propList;
	}

	/**
	 * IuWFNg̃NXׂđ啶ŕ\xB
	 * @return	x
	 */
	public String getObjLabel() {
		return objLabel;
	}

	/**
	 * wvΏۃIuWFNg̃NXԂB
	 * @return	wvΏۃIuWFNg̃NX
	 */
	public String getClsName() {
		return clsName;
	}
	
	/**
	 * objHelperƂłIuWFNgǂԂ
	 * @param obj	IuWFNg
	 * @return	wp[Ώۂ̃CX^Xۂ
	 */
	boolean isInstanceOfMyClass(Object obj) {
		// AOPpinstanceof̃`FbN𓮓Iɍs悤ɏC
		try {
			Object clsObj = Class.forName(clsName);
			if (obj.getClass().isInstance(clsObj))
				return (false);			
		}
		catch (Exception e) {
			return (false);
		}
		return (true);		
	}

	public static void main(String[] args) {
		for (int i = 0; i < args.length; i++) {
			try {
				DbHelper helper = new DbHelper(Class.forName(args[0]));
				System.out.println("<!-- CREATE TABLE FOR " + helper.getTableName() + " -->");
				System.out.println(helper.getCreateTableStmt());
				System.out.println("<!-- " + helper.getObjLabel() + ".hbm.xml -->");				
				System.out.println(helper.getHibernateXml());
			}
			catch (Exception e) {
				System.err.println("Class not found");
			}
		}
	}

}

