/*
 * 쐬: 2005/06/22
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
package unittest;

import org.springframework.test.AbstractTransactionalSpringContextTests;

import diaop.dao.IMember;
import diaop.model.Member;
import diaop.util.IDbUnitAware;

/**
 * DbTestCase1
 *
 * @author Hiroshi TAKEMOTO
 */
public class DbTestCase1
	extends AbstractTransactionalSpringContextTests {	
	private IMember			dao;

	public DbTestCase1() {
		super();
		// HibernateMemberDao protected template ̂ true
		this.setPopulateProtectedVariables(true);
	}
	
	/* ( Javadoc)
	 * @see org.springframework.test.AbstractDependencyInjectionSpringContextTests#getConfigLocations()
	 */
	public String[] getConfigLocations() {
		return new String[] {"/config-9.xml"};
	}

	/* ( Javadoc)
	 * @see org.springframework.test.AbstractTransactionalSpringContextTests#onSetUpInTransaction()
	 */
	public void onSetUpInTransaction() throws Exception {
		super.onSetUpInTransaction();
		dao = (IMember)getContext(getConfigLocations()[0]).getBean("memberDao");
	}
	
	/* ( Javadoc)
	 * @see org.springframework.test.AbstractTransactionalSpringContextTests#onTearDownInTransaction()
	 */
	public void onTearDownInTransaction() {
		super.onTearDownInTransaction();
	}	

	public void testFindMemberByID() {		
		((IDbUnitAware)dao).restore("bin/dump.xml");
				
		Member	member = dao.findMember(new Integer(1));
		assertEquals("Hiroshi TAKEMOTO", member.getName());
		assertEquals("Nakano-ku", member.getAddress());		
	}

}
